/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000 Sakai Hiroaki.                              */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Client 饹(Υ饹)Υ饤֥                           */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "ClientP.h"

/*****************************************************************************/
/* ؿ                                                                */
/*****************************************************************************/

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

Player ClientGetPlayer(Client client) { return (client->player); }

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Client ClientCreate(char * hostname, unsigned short int port,
		    char * name, int size, int * argcp, char * argv[])
{
  Client client;
  Path path;

  client = (Client)malloc(sizeof(_Client));
  if (client == NULL) ErrorExit("Cannot allocate memory for client.");

  path = PathCreateToCommunicateWithServer(hostname, port);
  if (path == NULL) ErrorExit("Cannot connect to server.");

  client->player = PlayerCreate(name, path, PLAYER_ACTIVE);
  if (client->player == NULL) ErrorExit("Cannot create my player.");

  /* ɽѤΥǥץ쥤κ */
  /* 饤Ȥ can't open display ȤˡФʤ
     褦ˡФȥͥĥ˥ǥץ쥤򥪡ץ󤹤 */
  client->display = DispCreate(argcp, argv, size);
  if (client->display == NULL) ErrorExit("Cannot create display.");

  /* ǡѤΥХåեγ */
  client->buffer = (char *)malloc(sizeof(char) * CLIENT_BUFFER_SIZE);
  if (client->buffer == NULL) ErrorExit("Cannot allocate memory for buffer.");

  /* ФȤΥͥ */
  sprintf(client->buffer, JOIN_REQUEST "\t%s\n", name);
  PathSendCharacters(PlayerGetPath(client->player), client->buffer, 0);

  /* ʲɬפ? */
#if 0
  PathRecvCharacters(PlayerGetPath(client->player), client->buffer, 200);
  PlayerReadData(client->player, client->buffer);
#endif

  client->buffer[0] = '\0'; /* Хåեν */

  return (client);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Client ClientDestroy(Client client)
{
  if (client == NULL) return (NULL);

  if (client->player) PlayerDestroy(client->player);

  if (client->display) DispDestroy(client->display);

  if (client->buffer) free(client->buffer);

  free(client);

  return (NULL);
}

/*---------------------------------------------------------------------------*/
/* 饤ȤνλȽ                                                    */
/*---------------------------------------------------------------------------*/

static int ClientIsOver(Client client)
{
  return (0);
}

/*---------------------------------------------------------------------------*/
/* 饤ȤΥ                                                    */
/*---------------------------------------------------------------------------*/

static int ClientMain(Client client)
{
  static char command[50];
  char * p;
  int len, i;
  double x, y;
  unsigned long int key_press;
  unsigned long int tank_action;
  int mx, my, angle, radius, state;
  int ret_flag = 0;
  int color_number;

  while (!ret_flag) {

    /* Ф̿ */
    while (1) {
      len = strlen(client->buffer);
      if (len >= CLIENT_BUFFER_SIZE)
	ErrorExit("Client buffer is too small.");
      for (i = 0; i < len; i++)
	if (client->buffer[i] == '\n') break;
      if (i < len) break;

      PathCheckRecvState(PlayerGetPath(client->player));
      while (!PathIsRecvStateActive(PlayerGetPath(client->player))) {
#if 1
	/*
	 *  sync ʤȡư۾٤ʤ롥
	 */
	DispSync(client->display);
	usleep(1000);
	return (1);
#else
	usleep(10000); /* Wait in 10 milliseconds */
	PathCheckRecvState(PlayerGetPath(client->player));
#endif
      }

      PathRecvCharacters(PlayerGetPath(client->player),
			 client->buffer + len, CLIENT_BUFFER_SIZE - len - 1);
    }

    /* ̿ν */
    sscanf(client->buffer, "%s", command);
    p = client->buffer;
    while (*(p++) != '\t') { /* None */ }

    if (!strcmp(command, DUMMY)) {
      /* None */
    } else if (!strcmp(command, TANK_DRAW)) {
      sscanf(p, "%lf %lf %d %d", &x, &y, &angle, &color_number);
      DispDrawTank(client->display, x, y, angle, color_number);
    } else if (!strcmp(command, CANON_DRAW)) {
      sscanf(p, "%lf %lf", &x, &y);
      DispDrawCanon(client->display, x, y);
    } else if (!strcmp(command, MISSILE_DRAW)) {
      sscanf(p, "%lf %lf", &x, &y);
      DispDrawMissile(client->display, x, y);
    } else if (!strcmp(command, EXPLOSION_DRAW)) {
      sscanf(p, "%lf %lf %d", &x, &y, &radius);
      DispDrawExplosion(client->display, x, y, radius);
    } else if (!strcmp(command, SEND_KEY)) {
      key_press = DispGetKeyPress(client->display);
      tank_action = TANK_NO_ACTION;
      if (key_press & DISP_UP_PRESS     ) tank_action |= TANK_GO_FORWARD;
      if (key_press & DISP_DOWN_PRESS   ) tank_action |= TANK_GO_BACKWARD;
      if (key_press & DISP_LEFT_PRESS   ) tank_action |= TANK_TURN_LEFT;
      if (key_press & DISP_RIGHT_PRESS  ) tank_action |= TANK_TURN_RIGHT;
      if (key_press & DISP_BUTTON1_PRESS) tank_action |= TANK_FIRE_MISSILE;
      if (key_press & DISP_BUTTON2_PRESS) tank_action |= TANK_FIRE_CANON;
      if (key_press & DISP_BUTTON4_PRESS) tank_action |= TANK_DEAD;
      sprintf(command, "%u", tank_action);
      /*
       * ǡž̤ưȡ®٤٤ʤΤǡ
       * ѥåɤƥǡ̤Ĵ롥
       * (TCP_NODELAYե饰ΩƤΤǡɬ̵ʤä)
       */
#if 0
      for (i = strlen(command); i < 10; i++) command[i] = ' ';
      PathSendCharacters(PlayerGetPath(client->player), command, 10);
#else
      PathSendCharacters(PlayerGetPath(client->player),
			 command, strlen(command) + 1);
#endif
    } else if (!strcmp(command, READ_KEY)) {
      ret_flag = 1;
    } else if (!strcmp(command, DISPLAY_COPY)) {
      sscanf(p, "%lf %lf", &x, &y);
      DispDrawDisplay(client->display, x, y);
    } else if (!strcmp(command, GAME_CLEAN)) {
      DispCleanGamePixmap(client->display);
    } else if (!strcmp(command, MAP_DRAW)) {
      sscanf(p, "%d %d %d", &mx, &my, &state);
      DispDrawMap(client->display, mx, my, state);
    } else if (!strcmp(command, DISPLAY_CLEAR)) {
      DispClearKeyPress(client->display);
      DispClearDisplay(client->display);
    } else if (!strcmp(command, TEXT_CLEAR)) {
      DispClearText(client->display);
    } else if (!strcmp(command, TEXT_DRAW)) {
      sscanf(p, "%d", &color_number);
      while (*(p++) != ' ') { /* None */ }
      DispDrawText(client->display, color_number, p);
    } else if (!strcmp(command, DELETE_YOU)) {
    } else if (!strcmp(command, DELETE_ME)) {
    } else if (!strcmp(command, TEST)) {
      fprintf(stderr, "test.\n");
    } else {
      /* Invalid command */
    }

    while (*(p++) != '\n') { /* None */ }
    for (i = 0; p[i] != '\0'; i++)
      client->buffer[i] = p[i];
    client->buffer[i] = '\0';

    /* ret_flag = 1; */
  }

#if 1
  DispFlush(client->display);
#else
  /*
   *  XSync() ȡԡɤ®ʤΤ
   * ơʤˤĤƥȿߤʤȤ
   * ԲĲʸݤΤǡDispFlush() ˤ롥
   */
  DispSync(client->display);
#endif

  return (0);
}

int ClientStart(Client client)
{
  DispStart(client->display, ClientMain, client);
  return (0);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
